Redmine - Defect #40099

User api filtering by status=* broke on upgrade from 5.0 to 5.1
2024-01-23 13:35 - Joan J

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Resolution: Fixed Affected version: 511
Description

| am testing the migration path from 5.0.5 to 5.1.1, we use an api call to get all users (active or not), since the user api shows only the
active accounts we where using "status=" or "status="" as a modifier to get all the fields

I've got the "status=" from this issue https://www.redmine.org/issues/32090

On 5.1.1, for any call with "status=" we get with the http code 422:
{
"errors": [

"Status cannot be blank"
]
1

*n

When | am using the filter "status="" the exit code is 500, and on the logs i see:

I, [2024-01-23T13:20:22.820689 #2787502] INFO -- : [0a29895f-ece3-4229-9e91-eeee48cdc573] Completed 500 Internal Server
Error in 21ms (ActiveRecord: 5.1ms | Allocations: 3061)

F, [2024-01-23T13:20:22.822546 #2787502] FATAL -- : [0a29895f-ece3-4229-9e91-eeee48cdc573]
[0a29895f-ece3-4229-9e91-eeee48cdc573] ActiveRecord::Statementinvalid (PG::InvalidTextRepresentation: ERROR: invalid input
syntax for type integer: "*"

LINE 1:...1, $2) AND (users.status <> 0) AND ((users.status IN ("')))

A

):
[0a29895f-ece3-4229-9e91-eeee48cdc573]
[0a29895f-ece3-4229-9e91-eeee48cdc573] app/controllers/users_controller.rb:64:in “index’

Related issues:
Related to Redmine - Patch #40124: Remove deprecated empty status param to ge... Closed
Has duplicate Redmine - Feature #32090: REST API: users: add support for stat... Closed

Associated revisions

Revision 22623 - 2024-01-25 05:58 - Marius BALTEANU
Add test cases for status=", status= and status=|1|3 (#40099).

Patch by Jens Kramer (@jkraemer) and Marius BALTEANU (@marius.balteanu).

Revision 22624 - 2024-01-25 06:08 - Marius BALTEANU

Enable "any" and "none" operators for status filter in User listing (#40099).

Patch by Jens Kramer (@jkraemer).

Revision 22625 - 2024-01-25 06:10 - Marius BALTEANU

Restores API compatibility to legacy status when status param is sent blank (status=) and it should return all users (#40099).

Revision 22632 - 2024-01-25 13:57 - Marius BALTEANU
Merged r22623, r22624 and r22625 from trunk to 5.1-stable (#40099).

Revision 22633 - 2024-01-25 16:31 - Marius BALTEANU
Adds deprecation warning when an empty status param (status=) is used to get all users from API (#40099).

Revision 22634 - 2024-01-25 16:32 - Marius BALTEANU
Merged r22633 from trunk to 5.1-stable (#40099).

Revision 22647 - 2024-01-27 02:47 - Go MAEDA
Fix RuboCop offense Layout/SpaceAfterComma (#40099).

History

#1 - 2024-01-23 14:42 - Marius BALTEANU

- Status changed from New to Confirmed

Users list was improved in Redmine 5.0 by using the same query mechanism as we have for issues, projects, etc (#37674) with filters and columns.
In order to keep the compatibility to legacy status and name query params, the API was adapted in r22343, but as | see now, the behaviour for
status= was not kept. If you change your query to status=1 it should return all active users. From my point of view, | prefer to not bring back the
behaviour with status= because | find it not intuitive.

| will take a look on the 500 error, it should not happen.
Please let me know what do you think about the first part.

#2 - 2024-01-23 15:21 - Joan J
Marius BALTEANU wrote in #note-1:

Users list was improved in Redmine 5.0 by using the same query mechanism as we have for issues, projects, etc (#37674) with filters and
columns. In order to keep the compatibility to legacy status and name query params, the AP| was adapted in 122343, but as | see now, the
behaviour for status= was not kept. If you change your query to status=1 it should return all active users. From my point of view, | prefer to not
bring back the behaviour with status= because | find it not intuitive.

| will take a look on the 500 error, it should not happen.

Please let me know what do you think about the first part.

| agree that "status=" is quite ugly and counterintuitive, for me it can go, having the status=" as with the issues if fine (or any other way to get the full
list)

#3 - 2024-01-24 03:57 - Marius BALTEANU

Joan J wrote in #note-2:

| agree that "status=" is quite ugly and counterintuitive, for me it can go, having the status=" as with the issues if fine (or any other way to get the
full list)

It seems that the only way to retrieve all users regardless their status using a single API request is to use the following query syntax
users.json?f[]=status_id&op[status_id]==8&v[status_id][]=1&v[status_id][]=2&v[status_id][]=3

| think we should add the "any" operator to status filter in order to enable the =* operator.

Also:

e | still need to investigate why short filters are not working for users listing
e |f the the 500 error happens only on Postgresgl because on MySQL is ok

#4 - 2024-01-24 08:36 - Jens Kramer

Looks like with MySQL, the ™" in where status IN (™) is cast to 0 so the query does not error out but gives just the anonymous user (which has
status=0 in my local test db).

Interestingly enough, at Planio we are adding the user status filter as :list_optional in UserQuery, which allows querying for any status with
?f[]=status&op[status]=". I'm not entirely sure why that did not make into the core patch. Probably we changed this at a later time:

diff --git a/app/models/user_query.rb b/app/models/user_query.rb
index bfb44cdad3..5051ceabeb 100644

--— a/app/models/user_query.rb

+++ b/app/models/user_query.rb

@@ -40,7 +40,7 Q@ class UserQuery < Query

def initialize_available_filters

2025-05-01 2/4


https://www.redmine.org/issues/37674
https://www.redmine.org/projects/redmine/repository/svn/revisions/22343
https://www.redmine.org/issues/37674
https://www.redmine.org/projects/redmine/repository/svn/revisions/22343

add_available_filter "status",
= type: :1list, values: ->{ user_statuses_values }
+ type: :list_optional, values: —->{ user_statuses_values }
add_available_filter "auth_source_id",
type: :list_optional, values: —->{ auth_sources_values }
add_available_filter "is_member_of_group",

With that, a quick fix for the API to support the status=" short query parameter would be:

iff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb
index 74elllde6..b806dca23 100644
-—— a/app/controllers/users_controller.rb
+++ b/app/controllers/users_controller.rb
@@ -48,7 +48,8 Q@ class UsersController < ApplicationController

# API backwards compatibility: handle legacy filter parameters

unless request.format.html?

if status_id = params|[:status].presence

= Qquery.add_filter 'status', '=', [status_id]
+ if status_id == '*'
+ Qquery.add_filter 'status', '*'
+ else
+ Qquery.add_filter 'status', '=', [status_id]
+ end
end
if name = params|[:name].presence
Qquery.add_filter 'name', '~', [name]

diff --git a/test/integration/api_test/users_test.rb b/test/integration/api_test/users_test.rb
index 1al682f32..3a38cfadl 100644
—-—— a/test/integration/api_test/users_test.rb
+++ b/test/integration/api_test/users_test.rb
@@ -90,6 +90,13 @@ class Redmine::ApiTest::UsersTest < Redmine::ApiTest::Base
users = User.where(status: 3)

assert_equal users.size, json['users'].size
+ get '/users.json', headers: credentials('admin'), params: { status: '*' }
+ assert_response :success
+ json = ActiveSupport::JSON.decode (response.body)
+ assert Jjson.key?('users')
+ users = User.logged
+ assert_equal users.size, json['users'].size
L
get '/users.json', headers: credentials('admin'), params: { name: 'jsmith' }

assert_response :success
json = ActiveSupport::JSON.decode (response.body)

#5 - 2024-01-25 04:48 - Marius BALTEANU
- Assignee set to Marius BALTEANU

- Target version set to 5.1.2

#6 - 2024-01-25 06:16 - Marius BALTEANU
Jens, I've added your test case and 2 other test cases to cover:
e the case when status is blank (status=), which should return all users as #32090 and rest_users point out.

e the case when status=", which should return all users as it works for other entities that support the "any" operator.
* the case when status=1|3, which should return all users with status 1 or 3 as it works for other entities that support the "any" operator.

The last two cases should be handled internally by short filters syntax, but their are not working because of r22343.

In r22625, I've simplified the fix to make all 3 test cases to pass.

Also:

1. We should update the wiki page after we close this.

2. For Redmine 6.0, | don't think we should support the awkward status= syntax, I'm in favour to add a deprecation message in 5.1.2 together with
these fixes and then remove it in 6.0.0.

What do you think? I'll merge this to 5.1-stable branch after your review.
#7 - 2024-01-25 09:33 - Jens Kramer

This looks great, nice to let the non-blank status parameter values just pass through to be handled by add_short_filter. And yes regarding the
deprecation of status=.
#8 - 2024-01-25 16:36 - Marius BALTEANU
- Status changed from Confirmed to Resolved

- Resolution set to Fixed

Joan J, the issue reported is now fixed and it will be available in 5.1.2.

#9 - 2024-01-25 16:39 - Marius BALTEANU

Jens Kramer wrote in #note-7:

This looks great, nice to let the non-blank status parameter values just pass through to be handled by add_short_filter. And yes regarding the
deprecation of status=.

All done. The removal is part of #40124.

#10 - 2024-01-25 16:39 - Marius BALTEANU
- Related to Patch #40124: Remove deprecated empty status param to get all users from APl added

#11 - 2024-01-25 16:39 - Marius BALTEANU
- Has duplicate Feature #32090: REST API: users: add support for status=* added

#12 - 2024-02-13 23:39 - Marius BALTEANU

- Status changed from Resolved to Closed

We just need to update API docs after the release.
